
#define	_CRT_SECURE_NO_WARNINGS

#include "common.h"
#include "Graph.h"

#define			RECORD			1
#define			NOT_RECORD		0

int g_VerTexNums = 7;			//	 

int g_RecordDT[11];				//	Ŀ  ϱ  迭
								//	迭 ̴  ŭ Ҵϸ ȴ.
								//	7 ξ ȴ.

/*
	б µ  ּ 
	ּ      ū  ʱȭ ʿϴ.
	  Ž ؼ   뺸    ߰ 
	    ؾ ϱ ̴.
*/
int g_MinCost = _CRT_INT_MAX;	//	 Ÿ int   ִ ִ  


/*	Ͽ   ȣ ġ о ׷ ϴ Լ	*/
void LoadDataFromFile(Graph* pPath);

/*
	SearchDFS Žϴ Լ,  curVertex 
	curVertex   ŽѴ.
	Ű cost  Ŀ  ̴.
*/
void SearchDFS(Graph* pPath, int curVertex, int cost);

int main(void)
{
	Graph graph;

	GraphInit(&graph, g_VerTexNums);

	LoadDataFromFile(&graph);

	//	  0° ̸, 
	//	İ  Ƿ cost 0 .
	SearchDFS(&graph, 0, 0);

	DestroyGraph(&graph);

	printf("%d\n", g_MinCost);

	return 0;
}

/*	Ͽ   ȣ ġ о ׷ ϴ Լ	*/
void LoadDataFromFile(Graph* pPath)
{
	FILE* pFile = fopen("Ȱ ±.txt", "r");
	int curVertex;		//	1
	int nextVertex;		//	2
	int cost;			//	  µ  

	while (!feof(pFile))
	{
		fscanf(pFile, "%d", &curVertex);
		fscanf(pFile, "%d", &nextVertex);
		fscanf(pFile, "%d", &cost);

		//	  ϰ, ġ ϴ Լ
		AddEdge(pPath, curVertex - 1, nextVertex - 1, cost);
	}
	fclose(pFile);
}

/*
	SearchDFS Žϴ Լ,  curVertex 
	curVertex   ŽѴ.
	Ű cost  Ŀ  ̴.
*/
void SearchDFS(Graph* pPath, int curVertex, int cost)
{
	int nextVertex;

	//	 Žϸ    
	//	g_MinCost  Ž Ѵ.
	//	̷ 쿡   ŽѴϴ g_MinCost 
	//	  ũ ̴.
	if (cost > g_MinCost)
	{
		return;
	}

	//	 Լ Ż     ̴.
	if (curVertex == g_VerTexNums - 1)
	{
		//	б µ  ּ 
		//	Ŀ  cost ũ Ѵ.
		if (cost < g_MinCost)
		{
			g_MinCost = cost;
		}
		return;
	}

	g_RecordDT[curVertex] = RECORD;	//	  .

	Vertex* pCurVertex = pPath->pVertexList[curVertex];
	
	while (pCurVertex != NULL)
	{
		nextVertex = pCurVertex->Dest;

		//	  ̹ Ŀ ̶ Ž  ϰ Ѵ.
		//	  ٽ ǵư   ̴.
		if (g_RecordDT[nextVertex] == NOT_RECORD)
		{
			//	nextVertex   ΰ Ž Ѵ.
			SearchDFS(pPath, nextVertex, cost + pCurVertex->Cost);

			//	Ž   nextVertex ٽ   Ѵ.
			g_RecordDT[nextVertex] = NOT_RECORD;
		}
		pCurVertex = pCurVertex->pNext;
	}
}

